*********************************************************************
      PROGRAM sumtally
*                                                                   *
*         Created by S. Hashimoto on 2014/07/09 (ver. 1.00)         *
*                                                                   *
*-------------------------------------------------------------------*
*                                                                   *
*     Purpose                                                       *
*         Obtain sum of results of tally                            *
*     Required files for run                                        *
*         Input file for this program                               *
*         Results of tally                                          *
*     Outputs                                                       *
*         Tally file                                                *
*                                                                   *
*********************************************************************
      implicit none

      integer :: stdin=5,stdout=6,stdout2=7,io=10,iodvh=8,ioimage=9
      integer, parameter :: nfmax=40
      integer :: ifile, nfile, i1, i2, i3, ios, nlength
      character(100) :: afileout, afile(nfmax)
      real(8) :: weight(nfmax), totweight, totfact
      logical Fex

      integer :: iread
      integer, parameter :: nread=1000000000
      character(200) :: aread, cnum, cpara
      character(4) :: caxis='axis'
      character(2) :: cx='x', cy='y', cz='z', cr='r', ct='t'
      character(2) :: cxy='xy', cyz='yz', cxz='xz', crz='rz'
      integer :: iaxis
      character(3) :: caxisp
      character(2) :: cnx='nx', cny='ny', cnz='nz'
      integer :: nx, ny, nz, nx0, ny0, nz0
      character(4) :: cxmin='xmin', cxmax='xmax', cymin='ymin'
      character(4) :: cymax='ymax', czmin='zmin', czmax='zmax'
      real(8) :: xmin, xmax, ymin, ymax, zmin, zmax
      real(8) :: xmin0, xmax0, ymin0, ymax0, zmin0, zmax0
      real(8) :: xdel, ydel, zdel

      character(7) :: cnewpage='newpage'
      character(7) :: csetc1='set: c1', csetc3='set: c3'
      real(8) :: smin, smax
      real(8) :: axmin, axmax, axdel, aymin, aymax, aydel
      character(2) :: cax, cay, canx, cany
      character(6) :: ckey
      character(6) :: ckey1='h2:  y', ckey2='hd:  y', ckey3='hc:  y'
      character(6) :: ckey4='hd2: y', ckey5='hc2: y', ckey6='h: n  '
      integer :: id1,id2,id3,nd1,nd2,nd3
      real(8),allocatable:: rdata(:,:,:), sdata(:,:,:)
      real(8),allocatable:: erdata(:,:,:), esdata(:,:,:)
      real(8),allocatable:: rxyz1(:), rxyz2(:)
      character(8) :: csumover='sum over'
      character(4) :: cxorg='xorg'
      character(9) :: cwtsc5='wt: s[c5]'

      character(10) :: ccontour='ContourMap'
      integer :: icontour
      integer :: icut, ncut
      character(200) :: cuts
      real(8) :: cutsmin, cutsmax, cutstmp
      character(4) :: cylog='ylog'

      character(9) :: cimage='WithImage'
      character(100) :: cifile
      integer :: image
      character(5) :: cgshow='gshow'

      character(3) :: cCDVH='DVH', cldvh='dvh'
      integer :: idvh
      real(8) :: roixmin, roixmax, roiymin, roiymax, roizmin, roizmax
      real(8) :: roi1min, roi1max, roi2min, roi2max, roi3min, roi3max
      real(8) :: xyz1min, xyz1max, xyz2min, xyz2max, xyz3min, xyz3max
      real(8) :: xyz1del, xyz2del, xyz3del, xyz1, xyz2, xyz3
      real(8) :: gymin, gymax, gydel
      integer :: ngy, igy
      real(8),allocatable:: DVH(:)
      real(8) :: totvol

!----------------------------------------------------------------------
* read sumtally.inp
c$$$      open(stdin,file='sumtally.inp')
      read(stdin,*) afileout
      open(stdout,file=afileout)
      read(stdin,*) totfact
      read(stdin,*) nfile
      if(nfile.gt.nfmax) then
         write(*,*)'ERROR: number of tally files is larger than',nfmax
         stop
      end if

         ifile=0
      do iread=1,nread
         read(stdin,*,iostat=ios) aread
         if (ios.lt.0) exit

         if (adjustl(aread).eq.ccontour) then
            icontour=1
            read(stdin,*,iostat=ios) icut
            if (icut.gt.0) then
               read(stdin,*,iostat=ios) cuts
               i1=index(cuts,'(')
               i2=index(cuts,',')
               if (i1+1.ge.i2-1) then
                  write(*,*)
     &                 'ERROR: Format for contour map is not correct.'
                  stop
               end if
               read(cuts(i1+1:i2-1),*) cutsmin
               i1=index(cuts,',',back=.true.)
               i2=index(cuts,')')
               if (i1+1.ge.i2-1) then
                  write(*,*)
     &                 'ERROR: Format for contour map is not correct.'
                  stop
               end if
               read(cuts(i1+1:i2-1),*) cutsmax
               if (cutsmin.gt.cutsmax) then
                  cutstmp=cutsmin
                  cutsmin=cutsmax
                  cutsmax=cutstmp
               end if
            end if

         else if (adjustl(aread).eq.cimage) then
            image=1
            read(stdin,*,iostat=ios) cifile
            if (ios.ne.0) then
               write(*,*) 'ERROR: Format of image file name'
               stop
            end if
            open(ioimage,file=cifile)

         else if (adjustl(aread).eq.cCDVH .or.
     &           adjustl(aread).eq.cldvh) then
            idvh=1
            read(stdin,*,iostat=ios) gymin, gymax, ngy
            read(stdin,*,iostat=ios)
     &           roixmin, roixmax, roiymin, roiymax, roizmin, roizmax
            if (ios.ne.0) then
               write(*,*)
     &              'ERROR: Format of Gy-mesh or ROI is not correct.'
               stop
            end if

            open(iodvh,file='DVH.out')

         else
            backspace(stdin)
            ifile=ifile+1
            read(stdin,*,iostat=ios) weight(ifile),afile(ifile)
            if (ios.ne.0) then
               write(*,*)
     &             'ERROR: Format of tally file names and their weights'
               stop
            end if
         end if

      end do

      if (ifile.ne.nfile) then
         write(*,*)'ERROR: number of written files does not equal to'
     1        ,nfile
         stop
      end if

      totweight=0d0
      do ifile=1,nfile
         totweight=totweight+weight(ifile)
      end do
      do ifile=1,nfile
         weight(ifile)=weight(ifile)/totweight
      end do

      close(stdin)


!----------------------------------------------------------------------
* open files of tally
      do ifile=1,nfile
         inquire(file=afile(ifile),exist=Fex)
         if(.not.Fex) then
            write(*,*)'ERROR: missing files of result of tally'
            stop
         endif
         open(io+ifile,file=afile(ifile))
      end do


!----------------------------------------------------------------------
* zero set 1
      nx=0
      ny=0
      nz=0
      xmin=0d0
      xmax=0d0
      ymin=0d0
      ymax=0d0
      zmin=0d0
      zmax=0d0

      smin=1e38
      smax=1e-31

!----------------------------------------------------------------------
* copy and paste echo part of tally files
      do ifile=1,nfile

      do iread=1,nread
         read(io+ifile,'(a)') aread

         if(aread(6:9).eq.caxis) then
            i1=index(aread,'=')
            i2=index(aread,'#')
            write(cnum,'(a)') aread(i1+1:i2-1)
            cpara=adjustl(cnum)
            if (ifile.eq.1) then
c$$$               if (cpara.eq.cxy .or. cpara.eq.cyz .or. cpara.eq.cxz
c$$$     1              .or. cpara.eq.crz) then
               if (cpara.eq.cxy .or. cpara.eq.cyz .or. cpara.eq.cxz
     1              ) then
                  iaxis=2
c$$$               else if (cpara.eq.cx .or. cpara.eq.cy .or. cpara.eq.cz
c$$$     1                 .or. cpara.eq.cr .or. cpara.eq.ct) then
               else if (cpara.eq.cx .or. cpara.eq.cy .or. cpara.eq.cz
     1                 ) then
                  iaxis=1
               else
                  write(*,*)'ERROR: This axis is not available.',cpara
                  stop
               end if
               caxisp=cpara
            else
               if (adjustl(caxisp).ne.cpara) then
                  write(*,*)'ERROR: no match axis of all files'
                  stop
               endif
            end if
         end if

* for nx, ny, nz
         if(aread(8:9).eq.cnx) then
            i1=index(aread,'=')
            i2=index(aread,'#')
            write(cnum,'(a)') aread(i1+1:i2-1)
            read(cnum,'(i17)') nx
         end if
         if(aread(8:9).eq.cny) then
            i1=index(aread,'=')
            i2=index(aread,'#')
            write(cnum,'(a)') aread(i1+1:i2-1)
            read(cnum,'(i17)') ny
         end if
         if(aread(8:9).eq.cnz) then
            i1=index(aread,'=')
            i2=index(aread,'#')
            write(cnum,'(a)') aread(i1+1:i2-1)
            read(cnum,'(i17)') nz
         end if

* for xmin, xmax, ymin, ymax, zmin, zmax
         if(aread(6:9).eq.cxmin) then
            i1=index(aread,'=')
            i2=index(aread,'#')
            write(cnum,'(a)') aread(i1+1:i2-1)
            read(cnum,*) xmin
         end if
         if(aread(6:9).eq.cxmax) then
            i1=index(aread,'=')
            i2=index(aread,'#')
            write(cnum,'(a)') aread(i1+1:i2-1)
            read(cnum,*) xmax
         end if
         if(aread(6:9).eq.cymin) then
            i1=index(aread,'=')
            i2=index(aread,'#')
            write(cnum,'(a)') aread(i1+1:i2-1)
            read(cnum,*) ymin
         end if
         if(aread(6:9).eq.cymax) then
            i1=index(aread,'=')
            i2=index(aread,'#')
            write(cnum,'(a)') aread(i1+1:i2-1)
            read(cnum,*) ymax
         end if
         if(aread(6:9).eq.czmin) then
            i1=index(aread,'=')
            i2=index(aread,'#')
            write(cnum,'(a)') aread(i1+1:i2-1)
            read(cnum,*) zmin
         end if
         if(aread(6:9).eq.czmax) then
            i1=index(aread,'=')
            i2=index(aread,'#')
            write(cnum,'(a)') aread(i1+1:i2-1)
            read(cnum,*) zmax
         end if

         nlength=len_trim(aread)
         if(ifile.eq.1) write(stdout,'(a)') aread(1:nlength)
         if(aread(2:8).eq.cnewpage) exit
      end do

      if(ifile.eq.1) then
         nx0=nx
         ny0=ny
         nz0=nz
         xmin0=xmin
         xmax0=xmax
         ymin0=ymin
         ymax0=ymax
         zmin0=zmin
         zmax0=zmax
      else
         if( nx.ne.nx0 .or. ny.ne.ny0 .or. nz.ne.nz0 ) then
            write(stdout,*)'ERROR: no match numbers of xyz mesh'
            stop
         end if
         if( xmin.ne.xmin0 .or. xmax.ne.xmax0 .or. ymin.ne.ymin0 .or.
     &        ymax.ne.ymax0 .or. zmin.ne.zmin0 .or. zmax.ne.zmax0) then
            write(stdout,*)'ERROR: no match values of x,y,z min and max'
            stop
         end if
      end if

      end do

      xdel=(xmax-xmin)/dble(nx)
      ydel=(ymax-ymin)/dble(ny)
      zdel=(zmax-zmin)/dble(nz)


!----------------------------------------------------------------------
* zero set 2
* for axis=xy,yz,xz
      if(iaxis.eq.2) then

         if (adjustl(caxisp).eq.'xy') then
            nd1=nx
            nd2=ny
            nd3=nz

            axmin=xmin
            axmax=xmax
            axdel=xdel
            cax=cx
            canx=cnx
            aymin=ymin
            aymax=ymax
            aydel=ydel
            cay=cy
            cany=cny
         else if (adjustl(caxisp).eq.'yz') then
            nd1=nz
            nd2=ny
            nd3=nx

            axmin=zmin
            axmax=zmax
            axdel=zdel
            cax=cz
            canx=cnz
            aymin=ymin
            aymax=ymax
            aydel=ydel
            cay=cy
            cany=cny
         else if (adjustl(caxisp).eq.'xz') then
            nd1=nz
            nd2=nx
            nd3=ny

            axmin=zmin
            axmax=zmax
            axdel=zdel
            cax=cz
            canx=cnz
            aymin=xmin
            aymax=xmax
            aydel=xdel
            cay=cx
            cany=cnx
         end if

         allocate(sdata(nd1,nd2,nd3))
         allocate(esdata(nd1,nd2,nd3))
         do id3=1,nd3
         do id2=1,nd2
         do id1=1,nd1
            sdata(id1,id2,id3)=0d0
            esdata(id1,id2,id3)=0d0
         end do
         end do
         end do

         allocate(rdata(nd1,nd2,nfile))
         allocate(erdata(nd1,nd2,nfile))

* open output file for error results
         i3=index(afileout,'.',back=.true.)
         nlength=len_trim(afileout)
         open(stdout2,
     &        file=afileout(1:i3-1)//'_err'//afileout(i3:nlength))

* open error files of tally
         do ifile=1,nfile
            i3=index(afile(ifile),'.',back=.true.)
            nlength=len_trim(afile(ifile))
            inquire(file
     1           =afile(ifile)(1:i3-1)//'_err'//afile(ifile)(i3:nlength)
     2           ,exist=Fex)
            if(.not.Fex)then
               write(*,*)'ERROR: missing error files of result of tally'
               stop
            endif
            open(io+nfmax+ifile,file
     &          =afile(ifile)(1:i3-1)//'_err'//afile(ifile)(i3:nlength))
         end do


* for axis=x,y,z
      else if(iaxis.eq.1) then

         if (adjustl(caxisp).eq.'x') then
            nd1=nx
            nd2=ny*nz
         else if (adjustl(caxisp).eq.'y') then
            nd1=ny
            nd2=nx*nz
         else if (adjustl(caxisp).eq.'z') then
            nd1=nz
            nd2=nx*ny
         end if
            nd3=1

         allocate(sdata(nd1,nd2,nd3))
         allocate(esdata(nd1,nd2,nd3))
         do id3=1,nd3
         do id2=1,nd2
         do id1=1,nd1
            sdata(id1,id2,id3)=0d0
            esdata(id1,id2,id3)=0d0
         end do
         end do
         end do

         allocate(rxyz1(nd1))
         allocate(rxyz2(nd1))
         allocate(rdata(nd1,nd2,nfile))
         allocate(erdata(nd1,nd2,nfile))

      end if


!----------------------------------------------------------------------
* tally file for axis=xy,yz,xz
      if(iaxis.eq.2) then

!----------------------------------------------------------------------
* start of do-loop for multiple pages
      do id3=1,nd3

* copy and paste angel parameters in each page
         do ifile=1,nfile

            do iread=1,nread
               read(io+ifile,'(a)') aread
               if(aread(1:7).eq.csetc1) exit
               nlength=len_trim(aread)
               if(ifile.eq.1) write(stdout,'(a)') aread(1:nlength)
            end do

            do iread=1,nread
               read(io+ifile,'(a)') aread
               if(aread(1:6).eq.ckey1 .or. aread(1:6).eq.ckey2 .or.
     1              aread(1:6).eq.ckey3 .or. aread(1:6).eq.ckey4 .or.
     2              aread(1:6).eq.ckey5) exit
            end do
            write(ckey,'(a)') aread(1:6)

* reading results of tally
            read(io+ifile,*)
     &           ((rdata(id1,id2,ifile), id1=1,nd1), id2=nd2,1,-1)

         end do

* summation of results of tally
         do ifile=1,nfile
            do id2=1,nd2
            do id1=1,nd1
               sdata(id1,id2,id3)=sdata(id1,id2,id3)
     &              +rdata(id1,id2,ifile)*weight(ifile)
            end do
            end do
         end do

* multiply sum of results of tally by totfact
         do id2=1,nd2
         do id1=1,nd1
            sdata(id1,id2,id3)=sdata(id1,id2,id3)*totfact

            if (sdata(id1,id2,id3).lt.0d0) then
               write(*,*)'ERROR: Negative data are not available.'
               stop
            end if

            if (sdata(id1,id2,id3).gt.0d0 .and.
     &           sdata(id1,id2,id3).lt.smin) smin=sdata(id1,id2,id3)
            if (sdata(id1,id2,id3).gt.smax) smax=sdata(id1,id2,id3)
         end do
         end do

* back to 'set: c1'
         do iread=1,nread
            backspace(io+nfile)
            read(io+nfile,'(a)') aread
            if(aread(1:7).eq.csetc1) exit
            backspace(io+nfile)
         end do
            nlength=len_trim(aread)
            write(stdout,'(a)') aread(1:nlength)

* write x,y,z minimum and maximum
         do iread=1,nread
            read(io+nfile,'(a)') aread
            if(aread(1:6).eq.ckey) exit
            if(aread(1:7).ne.csetc3) then
               nlength=len_trim(aread)
               write(stdout,'(a)') aread(1:nlength)
            else
               if (icontour.eq.1) then
                  smin=cutsmin
                  smax=cutsmax
               end if
               write(stdout,'(a7,a1,1p1d15.6,a5,1p1d15.6,a1)')
     &              csetc3,'[',smin,'] c4[',smax,']'
            end if
         end do
         if (icontour.eq.1) then
            write(stdout,'(a)') 'p: ZLIN NOLG IPD2 COLS'
            if (icut.gt.0) then
               nlength=len_trim(cuts)
               write(stdout,'(a8,i2,a6,a)') 'p: ICUT(',icut,') CUTS',
     &              cuts(1:nlength)
            end if
            nlength=len_trim(aread)
            write(aread(1:3),'(a3)') 'h2:'
            write(stdout,'(/a)') aread(1:nlength)
         else
            nlength=len_trim(aread)
            write(stdout,'(a)') aread(1:nlength)
         end if
         read(io+nfile,*)
     &        ((rdata(id1,id2,nfile), id1=1,nd1), id2=nd2,1,-1)

* write sum of results of tally
         write(stdout,'(1p10e11.3)')
     &        ((sdata(id1,id2,id3), id1=1,nd1), id2=nd2,1,-1)


* copy and paste gshow parameters drawing CT image
         if (image.eq.1) then
            nlength=len_trim(cifile)
            write(stdout,'(//a)') '#------------------------------'
            write(stdout,'(a,a)') '# gshow parameters from ',
     &           cifile(1:nlength)
            write(stdout,'(a)') '#------------------------------'

            do iread=1,nread
               read(ioimage,'(a)',iostat=ios) aread
               if (ios.lt.0) exit
               if (aread(3:7).eq.cgshow) exit
            end do
            read(ioimage,'(a)',iostat=ios) aread
            if (ios.lt.0) then
               write(*,*)
     &              'ERROR: Format of image file is not available.'
               stop
            end if
            do iread=1,nread
               read(ioimage,'(a)',iostat=ios) aread
               if (ios.lt.0) exit
               if (aread(1:9).eq.cwtsc5) exit
               nlength=len_trim(aread)
               write(stdout,'(a)') aread(1:nlength)
            end do
            do iread=1,nread
               read(ioimage,'(a)',iostat=ios) aread
               if (ios.lt.0) exit
               if (aread(2:8).eq.cnewpage) exit
            end do
         end if

* copy and paste gshow parameters in each page
         do ifile=1,nfile

            nlength=len_trim(afile(ifile))
            write(stdout,'(//a)') '#------------------------------'
            write(stdout,'(a,a)') '# gshow parameters from ',
     &           afile(ifile)(1:nlength)
            write(stdout,'(a)') '#------------------------------'

            if (ifile.ne.nfile) then

               do iread=1,nread
                  read(io+ifile,'(a)',iostat=ios) aread
                  if (ios.lt.0) exit
                  if (aread(4:7).eq.cxorg) exit
                  if (aread(1:9).eq.cwtsc5) exit
                  nlength=len_trim(aread)
                  write(stdout,'(a)') aread(1:nlength)
               end do
               do iread=1,nread
                  read(io+ifile,'(a)',iostat=ios) aread
                  if (ios.lt.0) exit
                  if (aread(2:8).eq.cnewpage) exit
               end do

            else if (ifile.eq.nfile) then

               do iread=1,nread
                  read(io+ifile,'(a)',iostat=ios) aread
                  if (ios.lt.0) exit
                  nlength=len_trim(aread)
                  write(stdout,'(a)') aread(1:nlength)
                  if (icontour.eq.1 .and.
     &                 aread(nlength-3:nlength).eq.cylog) then
                     write(stdout,'(a)') 'p: ylin'
                  end if
                  if (aread(2:8).eq.cnewpage) exit
               end do

            end if

         end do


* error file for axis=xy,yz,xz
* copy and paste angel parameters in each page
         do ifile=1,nfile

            do iread=1,nread
               read(io+nfmax+ifile,'(a)') aread
               nlength=len_trim(aread)
               if(ifile.eq.1) write(stdout2,'(a)') aread(1:nlength)
               if(aread(1:6).eq.ckey1 .or. aread(1:6).eq.ckey2 .or.
     1              aread(1:6).eq.ckey3 .or. aread(1:6).eq.ckey4 .or.
     2              aread(1:6).eq.ckey5) exit
            end do

* reading errors of tally
            read(io+nfmax+ifile,*)
     &           ((erdata(id1,id2,ifile), id1=1,nd1), id2=nd2,1,-1)

         end do

* summation of error results of tally
         do ifile=1,nfile
            do id2=1,nd2
            do id1=1,nd1
               esdata(id1,id2,id3)=esdata(id1,id2,id3)
     1              +(rdata(id1,id2,ifile)*erdata(id1,id2,ifile))**2
     2              *weight(ifile)**2
            end do
            end do
         end do

         do id2=1,nd2
         do id1=1,nd1
            if (sdata(id1,id2,id3).eq.0d0) then
               esdata(id1,id2,id3)=0d0
            else
               esdata(id1,id2,id3)=dsqrt(esdata(id1,id2,id3))*totfact
     &              /sdata(id1,id2,id3)
            end if
         end do
         end do

* write sum of errors of tally
         write(stdout2,'(1p10e11.3)')
     &        ((esdata(id1,id2,id3), id1=1,nd1), id2=nd2,1,-1)

* copy and paste gshow parameters in each page
         do ifile=1,nfile

            i3=index(afile(ifile),'.',back=.true.)
            nlength=len_trim(afile(ifile))
            write(stdout2,'(//a)') '#------------------------------'
            write(stdout2,'(a,a)') '# gshow parameters from ',
     &           afile(ifile)(1:i3-1)//'_err'//afile(ifile)(i3:nlength)
            write(stdout2,'(a)') '#------------------------------'

            if (ifile.ne.nfile) then

               do iread=1,nread
                  read(io+nfmax+ifile,'(a)',iostat=ios) aread
                  if (ios.lt.0) exit
                  if (aread(4:7).eq.cxorg) exit
                  if (aread(1:9).eq.cwtsc5) exit
                  nlength=len_trim(aread)
                  write(stdout2,'(a)') aread(1:nlength)
               end do
               do iread=1,nread
                  read(io+nfmax+ifile,'(a)',iostat=ios) aread
                  if (ios.lt.0) exit
                  if (aread(2:8).eq.cnewpage) exit
               end do

            else if (ifile.eq.nfile) then

               do iread=1,nread
                  read(io+nfmax+ifile,'(a)',iostat=ios) aread
                  if (ios.lt.0) exit
                  nlength=len_trim(aread)
                  write(stdout2,'(a)') aread(1:nlength)
                  if (aread(2:8).eq.cnewpage) exit
               end do

            end if

         end do


* end of do-loop for multiple pages
      end do

      do ifile=1,nfile
         close(io+ifile)
         close(io+nfmax+ifile)
      end do
      close(stdout)
      close(stdout2)


!----------------------------------------------------------------------
* calculation of dose volume histogram (DVH)
      if (idvh.eq.1) then
         gydel=(gymax-gymin)/dble(ngy)

         allocate(DVH(ngy))
         do igy=1,ngy
            DVH(igy)=0d0
         end do

         if (adjustl(caxisp).eq.'xy') then
            xyz1min=xmin
            xyz1max=xmax
            xyz1del=xdel
            xyz2min=ymin
            xyz2max=ymax
            xyz2del=ydel
            xyz3min=zmin
            xyz3max=zmax
            xyz3del=zdel

            roi1min=roixmin
            roi1max=roixmax
            roi2min=roiymin
            roi2max=roiymax
            roi3min=roizmin
            roi3max=roizmax
         else if (adjustl(caxisp).eq.'yz') then
            xyz1min=zmin
            xyz1max=zmax
            xyz1del=zdel
            xyz2min=ymin
            xyz2max=ymax
            xyz2del=ydel
            xyz3min=xmin
            xyz3max=xmax
            xyz3del=xdel

            roi1min=roizmin
            roi1max=roizmax
            roi2min=roiymin
            roi2max=roiymax
            roi3min=roixmin
            roi3max=roixmax
         else if (adjustl(caxisp).eq.'xz') then
            xyz1min=zmin
            xyz1max=zmax
            xyz1del=zdel
            xyz2min=xmin
            xyz2max=xmax
            xyz2del=xdel
            xyz3min=ymin
            xyz3max=ymax
            xyz3del=ydel

            roi1min=roizmin
            roi1max=roizmax
            roi2min=roixmin
            roi2max=roixmax
            roi3min=roiymin
            roi3max=roiymax
         end if


         do id3=1,nd3
            xyz3=xyz3min+(id3-1+0.5)*xyz3del
         do id2=1,nd2
            xyz2=xyz2min+(id2-1+0.5)*xyz2del
         do id1=1,nd1
            xyz1=xyz1min+(id1-1+0.5)*xyz1del

            if ( xyz1.ge.roi1min .and. xyz1.le.roi1max .and.
     1           xyz2.ge.roi2min .and. xyz2.le.roi2max .and.
     2           xyz3.ge.roi3min .and. xyz3.le.roi3max ) then

               if (sdata(id1,id2,id3).ge.gymin
     &              .and. sdata(id1,id2,id3).le.gymax) then
                  igy=idint((sdata(id1,id2,id3)-gymin)/gydel) +1
                  if (igy.gt.ngy) igy=ngy
                  DVH(igy)=DVH(igy) +xdel*ydel*zdel
               end if

            end if

         end do
         end do
         end do

         do igy=ngy-1,1, -1
            DVH(igy)=DVH(igy+1)+DVH(igy)
         end do
         if (DVH(1).eq.0d0) then
            write(*,*)'ERROR in calculation of DVH: ',
     &           'All data in ROI are 0.'
            stop
         end if

         do igy=ngy,1, -1
            DVH(igy)=DVH(igy)/DVH(1)
         end do

         do igy=1,ngy
            write(iodvh,'(1x,1p2d12.4,1p10d13.4)')
     &           gymin+(igy-1)*gydel,gymin+igy*gydel,DVH(igy)*100
         end do

         deallocate(DVH)
         close(iodvh)

      end if


      deallocate(sdata)
      deallocate(esdata)
      deallocate(rdata)
      deallocate(erdata)


!----------------------------------------------------------------------
* tally file for axis=x,y,z
      else if(iaxis.eq.1) then

!----------------------------------------------------------------------
* start of do-loop for multiple pages
      do id3=1,nd3
      do id2=1,nd2

* copy and paste angel parameters in each page
         do ifile=1,nfile

            do iread=1,nread
               read(io+ifile,'(a)') aread
               nlength=len_trim(aread)
               if(ifile.eq.1) write(stdout,'(a)') aread(1:nlength)
               if(aread(1:6).eq.ckey6) exit
            end do
            read(io+ifile,'(a)') aread
            nlength=len_trim(aread)
            if(ifile.eq.1) write(stdout,'(a)') aread(1:nlength)

* reading results of tally
            do id1=1,nd1
               read(io+ifile,'(1p3e13.4,1f8.4)')
     1              rxyz1(id1),rxyz2(id1),
     2              rdata(id1,id2,ifile),erdata(id1,id2,ifile)
            end do

         end do

* summation of results of tally
         do ifile=1,nfile
            do id1=1,nd1
               sdata(id1,id2,id3)=sdata(id1,id2,id3)
     &              +rdata(id1,id2,ifile)*weight(ifile)
            end do
         end do

* multiply sum of results of tally by totfact
         do id1=1,nd1
            sdata(id1,id2,id3)=sdata(id1,id2,id3)*totfact
         end do

* summation of error of tally
         do ifile=1,nfile
            do id1=1,nd1
               esdata(id1,id2,id3)=esdata(id1,id2,id3)
     1              +(rdata(id1,id2,ifile)*erdata(id1,id2,ifile))**2
     2              *weight(ifile)**2
            end do
         end do

         do id1=1,nd1
            if (sdata(id1,id2,id3).eq.0d0) then
               esdata(id1,id2,id3)=0d0
            else
               esdata(id1,id2,id3)=dsqrt(esdata(id1,id2,id3))*totfact
     &              /sdata(id1,id2,id3)
            end if
         end do

* write sum of results of tally
         do id1=1,nd1
            write(stdout,'(1p3e13.4,1f8.4)')
     1           rxyz1(id1),rxyz2(id1),
     2           sdata(id1,id2,id3),erdata(id1,id2,id3)
         end do

* copy and paste gshow parameters in each page
         do ifile=1,nfile

            do iread=1,nread
               read(io+ifile,'(a)',iostat=ios) aread
               if (ios.lt.0) exit
               nlength=len_trim(aread)
               if (ifile.eq.nfile .and. aread(5:12).ne.csumover)
     &              write(stdout,'(a)') aread(1:nlength)
               if (aread(2:8).eq.cnewpage) exit
            end do

         end do

* end of do-loop for multiple pages
      end do
      end do

      do ifile=1,nfile
         close(io+ifile)
      end do
      close(stdout)

      deallocate(rxyz1)
      deallocate(rxyz2)
      deallocate(sdata)
      deallocate(esdata)
      deallocate(rdata)
      deallocate(erdata)


      end if


!----------------------------------------------------------------------
      end PROGRAM sumtally
!----------------------------------------------------------------------
